Unit ADG2R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFG4R_p, UTAFSI_p;

procedure ADG2R(var A :Array of Real; var M :Integer; var N :Integer;
                var NLEAD :Array of Integer; var DET1 :Real;
                var DET2 :Real; var RCOND :Real; var Z :Array of Real;
                var IERR :Integer); 
implementation

procedure ADG2R(var A :Array of Real; var M :Integer; var N :Integer;
                var NLEAD :Array of Integer; var DET1 :Real;
                var DET2 :Real; var RCOND :Real; var Z :Array of Real;
                var IERR :Integer);
var
I :Integer;
X :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90;
begin
{ **************************************************************** }
{               }
{           .  }
{ **************************************************************** }
RCOND := 0.0;
DET1 := 0.0;
DET2 := 0.0;

{        }
X := 0.0;
_10:

{         N }
if ( M >= 1 ) and ( N >= 1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','D','G','2','R',IERR);
goto _90;
_20:
IERR := 0;
AFG4R(A,M,N,NLEAD,RCOND,Z,IERR);
if ( IERR = 0 ) 
 then goto _30;
UTAFSI('A','D','G','2','R',IERR);
goto _90;
_30:
DET1 := 1.0;
DET2 := 0.0;
for I:=1 to N do
 begin
  if ( NLEAD[I-1] <> I ) 
   then DET1 := -DET1;
  DET1 := A[(I-1)+(I-1)*M]*DET1;
_40:
  if ( Abs(DET1) >= 1.0 ) 
   then goto _50;
  DET1 := 10.0*DET1;
  DET2 := DET2 - 1.0;
  goto _40;
_50:
_60:
  if ( Abs(DET1) < 10.0 ) 
   then goto _70;
  DET1 := DET1/10.0;
  DET2 := DET2 + 1.0;
  goto _60;
_70:
_80:
 end;
_90:
end;

end.
